# Webhooks

## Domain Types

### connection.created

- `ConnectionCreatedWebhookEvent`

  - `api_version: string`

    API version for the webhook payload format

  - `created_at: string`

    When the event was created

  - `data: Data`

    The payment request, as returned by
    `GET /v3/payment_requests/{paymentRequestId}`.

    - `id: string`

      The payment request id.

    - `amount: number`

      What was charged at checkout, in the currency's minor
      units. In `subscription` mode this is the first invoice's
      total — all items after any discounts are applied.

    - `checkout_url: string`

      URL the recipient opens to pay
      (`https://zero.linqapp.com/pay/{slug}?session=...`).

    - `created_at: string`

    - `currency: string`

    - `object: string`

    - `status: "succeeded" | "failed" | "canceled" | "expired"`

      - `"succeeded"`

      - `"failed"`

      - `"canceled"`

      - `"expired"`

    - `description?: string`

    - `discount?: Discount`

      Subscription mode — the discount Stripe applied, read back
      from the coupon. Absent when none was applied.

      - `coupon?: string`

      - `label?: string`

        Name of the coupon/promo code displayed to customers.

      - `promotion_code?: string`

    - `interval?: "day" | "week" | "month" | "year"`

      Subscription mode — how often the subscription renews.

      - `"day"`

      - `"week"`

      - `"month"`

      - `"year"`

    - `interval_count?: number`

      Subscription mode — intervals per renewal.

    - `metadata?: Record<string, string>`

    - `mode?: "payment" | "subscription"`

      Whether the request collected a one-time charge or started a subscription.

      - `"payment"`

      - `"subscription"`

    - `natural?: Natural`

      Natural-rail join keys, present when `rail: natural`.

      - `payment_request_id?: string`

        The Natural payment request (`prq_...`).

      - `transaction_id?: string`

        The settled transaction (`txn_...`).

    - `price_id?: string`

      Subscription mode — the recurring price subscribed to.

    - `quantity?: number`

      Subscription mode — units of the price subscribed to.

    - `rail?: "stripe" | "natural"`

      The rail this request settled on.

      - `"stripe"`

      - `"natural"`

    - `stripe?: Stripe`

      Ids of the Stripe objects on your connected account — join
      keys into your own Stripe Dashboard/API. Manage a
      subscription's post-checkout lifecycle with `subscription_id`.

      - `customer_id?: string`

        The Customer the request is attached to (`cus_...`).
        Always set in subscription mode; set in payment mode
        only when the request was created with a `customer_id`.

      - `payment_intent_id?: string`

        The PaymentIntent collected at checkout (`pi_...`).

      - `subscription_id?: string`

        Subscription mode — the Subscription (`sub_...`).

    - `trial_end?: string`

      Subscription mode — when the free trial ends and the first
      charge happens. On a trial request, `payment.succeeded`
      means the payment method was collected ($0 moved).

    - `updated_at?: string`

  - `event_id: string`

    Unique identifier for this event (for deduplication)

  - `event_type: "payment.succeeded" | "payment.canceled" | "payment.expired" | 66 more`

    - `"payment.succeeded"`

    - `"payment.canceled"`

    - `"payment.expired"`

    - `"message.sent"`

    - `"message.received"`

    - `"message.read"`

    - `"message.delivered"`

    - `"message.failed"`

    - `"message.edited"`

    - `"reaction.added"`

    - `"reaction.removed"`

    - `"poll.received"`

    - `"poll.failed"`

    - `"poll.sent"`

    - `"poll.delivered"`

    - `"poll.read"`

    - `"poll.updated"`

    - `"poll.vote.added"`

    - `"poll.vote.removed"`

    - `"poll.reaction.added"`

    - `"participant.added"`

    - `"participant.removed"`

    - `"chat.created"`

    - `"chat.group_name_updated"`

    - `"chat.group_icon_updated"`

    - `"chat.group_name_update_failed"`

    - `"chat.group_icon_update_failed"`

    - `"chat.background_updated"`

    - `"chat.background_update_failed"`

    - `"chat.typing_indicator.started"`

    - `"chat.typing_indicator.stopped"`

    - `"phone_number.status_updated"`

    - `"phone_number.assigned"`

    - `"phone_number.released"`

    - `"phone_number.line_type_updated"`

    - `"contact_card.received"`

    - `"location.sharing.started"`

    - `"location.sharing.stopped"`

    - `"payment.declined"`

    - `"payment.authorized"`

    - `"connection.created"`

    - `"connection.revoked"`

    - `"zero_day_retention.updated"`

    - `"phone_number.forwarding_updated"`

    - `"environment.line_moved"`

    - `"contact_card.created"`

    - `"contact_card.updated"`

    - `"contact_card.deleted"`

    - `"api_token.created"`

    - `"api_token.renamed"`

    - `"api_token.expiry_scheduled"`

    - `"api_token.expired"`

    - `"api_token.activated"`

    - `"api_token.deleted"`

    - `"environment.created"`

    - `"environment.renamed"`

    - `"environment.deleted"`

    - `"webhook_subscription.created"`

    - `"webhook_subscription.deleted"`

    - `"webhook_subscription.target_url_changed"`

    - `"webhook_subscription.enabled"`

    - `"webhook_subscription.disabled"`

    - `"webhook_subscription.events.updated"`

    - `"webhook_subscription.phone_numbers.updated"`

    - `"webhook_subscription.routing_headers_set"`

    - `"webhook_subscription.routing_headers_cleared"`

    - `"team_member.added"`

    - `"team_member.signed_in"`

    - `"team_member.signed_out"`

  - `partner_id: string`

    Partner identifier. Present on all webhooks for cross-referencing.

  - `trace_id: string`

    Trace ID for debugging and correlation across systems.

  - `webhook_version: string`

    Date-based webhook payload version.
    Determined by the `?version=` query parameter in your webhook subscription URL.
    If no version parameter is specified, defaults based on subscription creation date.

### connection.revoked

- `ConnectionRevokedWebhookEvent`

  - `api_version: string`

    API version for the webhook payload format

  - `created_at: string`

    When the event was created

  - `data: Data`

    The payment request, as returned by
    `GET /v3/payment_requests/{paymentRequestId}`.

    - `id: string`

      The payment request id.

    - `amount: number`

      What was charged at checkout, in the currency's minor
      units. In `subscription` mode this is the first invoice's
      total — all items after any discounts are applied.

    - `checkout_url: string`

      URL the recipient opens to pay
      (`https://zero.linqapp.com/pay/{slug}?session=...`).

    - `created_at: string`

    - `currency: string`

    - `object: string`

    - `status: "succeeded" | "failed" | "canceled" | "expired"`

      - `"succeeded"`

      - `"failed"`

      - `"canceled"`

      - `"expired"`

    - `description?: string`

    - `discount?: Discount`

      Subscription mode — the discount Stripe applied, read back
      from the coupon. Absent when none was applied.

      - `coupon?: string`

      - `label?: string`

        Name of the coupon/promo code displayed to customers.

      - `promotion_code?: string`

    - `interval?: "day" | "week" | "month" | "year"`

      Subscription mode — how often the subscription renews.

      - `"day"`

      - `"week"`

      - `"month"`

      - `"year"`

    - `interval_count?: number`

      Subscription mode — intervals per renewal.

    - `metadata?: Record<string, string>`

    - `mode?: "payment" | "subscription"`

      Whether the request collected a one-time charge or started a subscription.

      - `"payment"`

      - `"subscription"`

    - `natural?: Natural`

      Natural-rail join keys, present when `rail: natural`.

      - `payment_request_id?: string`

        The Natural payment request (`prq_...`).

      - `transaction_id?: string`

        The settled transaction (`txn_...`).

    - `price_id?: string`

      Subscription mode — the recurring price subscribed to.

    - `quantity?: number`

      Subscription mode — units of the price subscribed to.

    - `rail?: "stripe" | "natural"`

      The rail this request settled on.

      - `"stripe"`

      - `"natural"`

    - `stripe?: Stripe`

      Ids of the Stripe objects on your connected account — join
      keys into your own Stripe Dashboard/API. Manage a
      subscription's post-checkout lifecycle with `subscription_id`.

      - `customer_id?: string`

        The Customer the request is attached to (`cus_...`).
        Always set in subscription mode; set in payment mode
        only when the request was created with a `customer_id`.

      - `payment_intent_id?: string`

        The PaymentIntent collected at checkout (`pi_...`).

      - `subscription_id?: string`

        Subscription mode — the Subscription (`sub_...`).

    - `trial_end?: string`

      Subscription mode — when the free trial ends and the first
      charge happens. On a trial request, `payment.succeeded`
      means the payment method was collected ($0 moved).

    - `updated_at?: string`

  - `event_id: string`

    Unique identifier for this event (for deduplication)

  - `event_type: "payment.succeeded" | "payment.canceled" | "payment.expired" | 66 more`

    - `"payment.succeeded"`

    - `"payment.canceled"`

    - `"payment.expired"`

    - `"message.sent"`

    - `"message.received"`

    - `"message.read"`

    - `"message.delivered"`

    - `"message.failed"`

    - `"message.edited"`

    - `"reaction.added"`

    - `"reaction.removed"`

    - `"poll.received"`

    - `"poll.failed"`

    - `"poll.sent"`

    - `"poll.delivered"`

    - `"poll.read"`

    - `"poll.updated"`

    - `"poll.vote.added"`

    - `"poll.vote.removed"`

    - `"poll.reaction.added"`

    - `"participant.added"`

    - `"participant.removed"`

    - `"chat.created"`

    - `"chat.group_name_updated"`

    - `"chat.group_icon_updated"`

    - `"chat.group_name_update_failed"`

    - `"chat.group_icon_update_failed"`

    - `"chat.background_updated"`

    - `"chat.background_update_failed"`

    - `"chat.typing_indicator.started"`

    - `"chat.typing_indicator.stopped"`

    - `"phone_number.status_updated"`

    - `"phone_number.assigned"`

    - `"phone_number.released"`

    - `"phone_number.line_type_updated"`

    - `"contact_card.received"`

    - `"location.sharing.started"`

    - `"location.sharing.stopped"`

    - `"payment.declined"`

    - `"payment.authorized"`

    - `"connection.created"`

    - `"connection.revoked"`

    - `"zero_day_retention.updated"`

    - `"phone_number.forwarding_updated"`

    - `"environment.line_moved"`

    - `"contact_card.created"`

    - `"contact_card.updated"`

    - `"contact_card.deleted"`

    - `"api_token.created"`

    - `"api_token.renamed"`

    - `"api_token.expiry_scheduled"`

    - `"api_token.expired"`

    - `"api_token.activated"`

    - `"api_token.deleted"`

    - `"environment.created"`

    - `"environment.renamed"`

    - `"environment.deleted"`

    - `"webhook_subscription.created"`

    - `"webhook_subscription.deleted"`

    - `"webhook_subscription.target_url_changed"`

    - `"webhook_subscription.enabled"`

    - `"webhook_subscription.disabled"`

    - `"webhook_subscription.events.updated"`

    - `"webhook_subscription.phone_numbers.updated"`

    - `"webhook_subscription.routing_headers_set"`

    - `"webhook_subscription.routing_headers_cleared"`

    - `"team_member.added"`

    - `"team_member.signed_in"`

    - `"team_member.signed_out"`

  - `partner_id: string`

    Partner identifier. Present on all webhooks for cross-referencing.

  - `trace_id: string`

    Trace ID for debugging and correlation across systems.

  - `webhook_version: string`

    Date-based webhook payload version.
    Determined by the `?version=` query parameter in your webhook subscription URL.
    If no version parameter is specified, defaults based on subscription creation date.

### payment.authorized

- `PaymentAuthorizedWebhookEvent`

  - `api_version: string`

    API version for the webhook payload format

  - `created_at: string`

    When the event was created

  - `data: Data`

    The payment request, as returned by
    `GET /v3/payment_requests/{paymentRequestId}`.

    - `id: string`

      The payment request id.

    - `amount: number`

      What was charged at checkout, in the currency's minor
      units. In `subscription` mode this is the first invoice's
      total — all items after any discounts are applied.

    - `checkout_url: string`

      URL the recipient opens to pay
      (`https://zero.linqapp.com/pay/{slug}?session=...`).

    - `created_at: string`

    - `currency: string`

    - `object: string`

    - `status: "succeeded" | "failed" | "canceled" | "expired"`

      - `"succeeded"`

      - `"failed"`

      - `"canceled"`

      - `"expired"`

    - `description?: string`

    - `discount?: Discount`

      Subscription mode — the discount Stripe applied, read back
      from the coupon. Absent when none was applied.

      - `coupon?: string`

      - `label?: string`

        Name of the coupon/promo code displayed to customers.

      - `promotion_code?: string`

    - `interval?: "day" | "week" | "month" | "year"`

      Subscription mode — how often the subscription renews.

      - `"day"`

      - `"week"`

      - `"month"`

      - `"year"`

    - `interval_count?: number`

      Subscription mode — intervals per renewal.

    - `metadata?: Record<string, string>`

    - `mode?: "payment" | "subscription"`

      Whether the request collected a one-time charge or started a subscription.

      - `"payment"`

      - `"subscription"`

    - `natural?: Natural`

      Natural-rail join keys, present when `rail: natural`.

      - `payment_request_id?: string`

        The Natural payment request (`prq_...`).

      - `transaction_id?: string`

        The settled transaction (`txn_...`).

    - `price_id?: string`

      Subscription mode — the recurring price subscribed to.

    - `quantity?: number`

      Subscription mode — units of the price subscribed to.

    - `rail?: "stripe" | "natural"`

      The rail this request settled on.

      - `"stripe"`

      - `"natural"`

    - `stripe?: Stripe`

      Ids of the Stripe objects on your connected account — join
      keys into your own Stripe Dashboard/API. Manage a
      subscription's post-checkout lifecycle with `subscription_id`.

      - `customer_id?: string`

        The Customer the request is attached to (`cus_...`).
        Always set in subscription mode; set in payment mode
        only when the request was created with a `customer_id`.

      - `payment_intent_id?: string`

        The PaymentIntent collected at checkout (`pi_...`).

      - `subscription_id?: string`

        Subscription mode — the Subscription (`sub_...`).

    - `trial_end?: string`

      Subscription mode — when the free trial ends and the first
      charge happens. On a trial request, `payment.succeeded`
      means the payment method was collected ($0 moved).

    - `updated_at?: string`

  - `event_id: string`

    Unique identifier for this event (for deduplication)

  - `event_type: "payment.succeeded" | "payment.canceled" | "payment.expired" | 66 more`

    - `"payment.succeeded"`

    - `"payment.canceled"`

    - `"payment.expired"`

    - `"message.sent"`

    - `"message.received"`

    - `"message.read"`

    - `"message.delivered"`

    - `"message.failed"`

    - `"message.edited"`

    - `"reaction.added"`

    - `"reaction.removed"`

    - `"poll.received"`

    - `"poll.failed"`

    - `"poll.sent"`

    - `"poll.delivered"`

    - `"poll.read"`

    - `"poll.updated"`

    - `"poll.vote.added"`

    - `"poll.vote.removed"`

    - `"poll.reaction.added"`

    - `"participant.added"`

    - `"participant.removed"`

    - `"chat.created"`

    - `"chat.group_name_updated"`

    - `"chat.group_icon_updated"`

    - `"chat.group_name_update_failed"`

    - `"chat.group_icon_update_failed"`

    - `"chat.background_updated"`

    - `"chat.background_update_failed"`

    - `"chat.typing_indicator.started"`

    - `"chat.typing_indicator.stopped"`

    - `"phone_number.status_updated"`

    - `"phone_number.assigned"`

    - `"phone_number.released"`

    - `"phone_number.line_type_updated"`

    - `"contact_card.received"`

    - `"location.sharing.started"`

    - `"location.sharing.stopped"`

    - `"payment.declined"`

    - `"payment.authorized"`

    - `"connection.created"`

    - `"connection.revoked"`

    - `"zero_day_retention.updated"`

    - `"phone_number.forwarding_updated"`

    - `"environment.line_moved"`

    - `"contact_card.created"`

    - `"contact_card.updated"`

    - `"contact_card.deleted"`

    - `"api_token.created"`

    - `"api_token.renamed"`

    - `"api_token.expiry_scheduled"`

    - `"api_token.expired"`

    - `"api_token.activated"`

    - `"api_token.deleted"`

    - `"environment.created"`

    - `"environment.renamed"`

    - `"environment.deleted"`

    - `"webhook_subscription.created"`

    - `"webhook_subscription.deleted"`

    - `"webhook_subscription.target_url_changed"`

    - `"webhook_subscription.enabled"`

    - `"webhook_subscription.disabled"`

    - `"webhook_subscription.events.updated"`

    - `"webhook_subscription.phone_numbers.updated"`

    - `"webhook_subscription.routing_headers_set"`

    - `"webhook_subscription.routing_headers_cleared"`

    - `"team_member.added"`

    - `"team_member.signed_in"`

    - `"team_member.signed_out"`

  - `partner_id: string`

    Partner identifier. Present on all webhooks for cross-referencing.

  - `trace_id: string`

    Trace ID for debugging and correlation across systems.

  - `webhook_version: string`

    Date-based webhook payload version.
    Determined by the `?version=` query parameter in your webhook subscription URL.
    If no version parameter is specified, defaults based on subscription creation date.

### payment.canceled

- `PaymentCanceledWebhookEvent`

  - `api_version: string`

    API version for the webhook payload format

  - `created_at: string`

    When the event was created

  - `data: Data`

    The payment request, as returned by
    `GET /v3/payment_requests/{paymentRequestId}`.

    - `id: string`

      The payment request id.

    - `amount: number`

      What was charged at checkout, in the currency's minor
      units. In `subscription` mode this is the first invoice's
      total — all items after any discounts are applied.

    - `checkout_url: string`

      URL the recipient opens to pay
      (`https://zero.linqapp.com/pay/{slug}?session=...`).

    - `created_at: string`

    - `currency: string`

    - `object: string`

    - `status: "succeeded" | "failed" | "canceled" | "expired"`

      - `"succeeded"`

      - `"failed"`

      - `"canceled"`

      - `"expired"`

    - `description?: string`

    - `discount?: Discount`

      Subscription mode — the discount Stripe applied, read back
      from the coupon. Absent when none was applied.

      - `coupon?: string`

      - `label?: string`

        Name of the coupon/promo code displayed to customers.

      - `promotion_code?: string`

    - `interval?: "day" | "week" | "month" | "year"`

      Subscription mode — how often the subscription renews.

      - `"day"`

      - `"week"`

      - `"month"`

      - `"year"`

    - `interval_count?: number`

      Subscription mode — intervals per renewal.

    - `metadata?: Record<string, string>`

    - `mode?: "payment" | "subscription"`

      Whether the request collected a one-time charge or started a subscription.

      - `"payment"`

      - `"subscription"`

    - `natural?: Natural`

      Natural-rail join keys, present when `rail: natural`.

      - `payment_request_id?: string`

        The Natural payment request (`prq_...`).

      - `transaction_id?: string`

        The settled transaction (`txn_...`).

    - `price_id?: string`

      Subscription mode — the recurring price subscribed to.

    - `quantity?: number`

      Subscription mode — units of the price subscribed to.

    - `rail?: "stripe" | "natural"`

      The rail this request settled on.

      - `"stripe"`

      - `"natural"`

    - `stripe?: Stripe`

      Ids of the Stripe objects on your connected account — join
      keys into your own Stripe Dashboard/API. Manage a
      subscription's post-checkout lifecycle with `subscription_id`.

      - `customer_id?: string`

        The Customer the request is attached to (`cus_...`).
        Always set in subscription mode; set in payment mode
        only when the request was created with a `customer_id`.

      - `payment_intent_id?: string`

        The PaymentIntent collected at checkout (`pi_...`).

      - `subscription_id?: string`

        Subscription mode — the Subscription (`sub_...`).

    - `trial_end?: string`

      Subscription mode — when the free trial ends and the first
      charge happens. On a trial request, `payment.succeeded`
      means the payment method was collected ($0 moved).

    - `updated_at?: string`

  - `event_id: string`

    Unique identifier for this event (for deduplication)

  - `event_type: "payment.succeeded" | "payment.canceled" | "payment.expired" | 66 more`

    - `"payment.succeeded"`

    - `"payment.canceled"`

    - `"payment.expired"`

    - `"message.sent"`

    - `"message.received"`

    - `"message.read"`

    - `"message.delivered"`

    - `"message.failed"`

    - `"message.edited"`

    - `"reaction.added"`

    - `"reaction.removed"`

    - `"poll.received"`

    - `"poll.failed"`

    - `"poll.sent"`

    - `"poll.delivered"`

    - `"poll.read"`

    - `"poll.updated"`

    - `"poll.vote.added"`

    - `"poll.vote.removed"`

    - `"poll.reaction.added"`

    - `"participant.added"`

    - `"participant.removed"`

    - `"chat.created"`

    - `"chat.group_name_updated"`

    - `"chat.group_icon_updated"`

    - `"chat.group_name_update_failed"`

    - `"chat.group_icon_update_failed"`

    - `"chat.background_updated"`

    - `"chat.background_update_failed"`

    - `"chat.typing_indicator.started"`

    - `"chat.typing_indicator.stopped"`

    - `"phone_number.status_updated"`

    - `"phone_number.assigned"`

    - `"phone_number.released"`

    - `"phone_number.line_type_updated"`

    - `"contact_card.received"`

    - `"location.sharing.started"`

    - `"location.sharing.stopped"`

    - `"payment.declined"`

    - `"payment.authorized"`

    - `"connection.created"`

    - `"connection.revoked"`

    - `"zero_day_retention.updated"`

    - `"phone_number.forwarding_updated"`

    - `"environment.line_moved"`

    - `"contact_card.created"`

    - `"contact_card.updated"`

    - `"contact_card.deleted"`

    - `"api_token.created"`

    - `"api_token.renamed"`

    - `"api_token.expiry_scheduled"`

    - `"api_token.expired"`

    - `"api_token.activated"`

    - `"api_token.deleted"`

    - `"environment.created"`

    - `"environment.renamed"`

    - `"environment.deleted"`

    - `"webhook_subscription.created"`

    - `"webhook_subscription.deleted"`

    - `"webhook_subscription.target_url_changed"`

    - `"webhook_subscription.enabled"`

    - `"webhook_subscription.disabled"`

    - `"webhook_subscription.events.updated"`

    - `"webhook_subscription.phone_numbers.updated"`

    - `"webhook_subscription.routing_headers_set"`

    - `"webhook_subscription.routing_headers_cleared"`

    - `"team_member.added"`

    - `"team_member.signed_in"`

    - `"team_member.signed_out"`

  - `partner_id: string`

    Partner identifier. Present on all webhooks for cross-referencing.

  - `trace_id: string`

    Trace ID for debugging and correlation across systems.

  - `webhook_version: string`

    Date-based webhook payload version.
    Determined by the `?version=` query parameter in your webhook subscription URL.
    If no version parameter is specified, defaults based on subscription creation date.

### payment.declined

- `PaymentDeclinedWebhookEvent`

  - `api_version: string`

    API version for the webhook payload format

  - `created_at: string`

    When the event was created

  - `data: Data`

    The payment request, as returned by
    `GET /v3/payment_requests/{paymentRequestId}`.

    - `id: string`

      The payment request id.

    - `amount: number`

      What was charged at checkout, in the currency's minor
      units. In `subscription` mode this is the first invoice's
      total — all items after any discounts are applied.

    - `checkout_url: string`

      URL the recipient opens to pay
      (`https://zero.linqapp.com/pay/{slug}?session=...`).

    - `created_at: string`

    - `currency: string`

    - `object: string`

    - `status: "succeeded" | "failed" | "canceled" | "expired"`

      - `"succeeded"`

      - `"failed"`

      - `"canceled"`

      - `"expired"`

    - `description?: string`

    - `discount?: Discount`

      Subscription mode — the discount Stripe applied, read back
      from the coupon. Absent when none was applied.

      - `coupon?: string`

      - `label?: string`

        Name of the coupon/promo code displayed to customers.

      - `promotion_code?: string`

    - `interval?: "day" | "week" | "month" | "year"`

      Subscription mode — how often the subscription renews.

      - `"day"`

      - `"week"`

      - `"month"`

      - `"year"`

    - `interval_count?: number`

      Subscription mode — intervals per renewal.

    - `metadata?: Record<string, string>`

    - `mode?: "payment" | "subscription"`

      Whether the request collected a one-time charge or started a subscription.

      - `"payment"`

      - `"subscription"`

    - `natural?: Natural`

      Natural-rail join keys, present when `rail: natural`.

      - `payment_request_id?: string`

        The Natural payment request (`prq_...`).

      - `transaction_id?: string`

        The settled transaction (`txn_...`).

    - `price_id?: string`

      Subscription mode — the recurring price subscribed to.

    - `quantity?: number`

      Subscription mode — units of the price subscribed to.

    - `rail?: "stripe" | "natural"`

      The rail this request settled on.

      - `"stripe"`

      - `"natural"`

    - `stripe?: Stripe`

      Ids of the Stripe objects on your connected account — join
      keys into your own Stripe Dashboard/API. Manage a
      subscription's post-checkout lifecycle with `subscription_id`.

      - `customer_id?: string`

        The Customer the request is attached to (`cus_...`).
        Always set in subscription mode; set in payment mode
        only when the request was created with a `customer_id`.

      - `payment_intent_id?: string`

        The PaymentIntent collected at checkout (`pi_...`).

      - `subscription_id?: string`

        Subscription mode — the Subscription (`sub_...`).

    - `trial_end?: string`

      Subscription mode — when the free trial ends and the first
      charge happens. On a trial request, `payment.succeeded`
      means the payment method was collected ($0 moved).

    - `updated_at?: string`

  - `event_id: string`

    Unique identifier for this event (for deduplication)

  - `event_type: "payment.succeeded" | "payment.canceled" | "payment.expired" | 66 more`

    - `"payment.succeeded"`

    - `"payment.canceled"`

    - `"payment.expired"`

    - `"message.sent"`

    - `"message.received"`

    - `"message.read"`

    - `"message.delivered"`

    - `"message.failed"`

    - `"message.edited"`

    - `"reaction.added"`

    - `"reaction.removed"`

    - `"poll.received"`

    - `"poll.failed"`

    - `"poll.sent"`

    - `"poll.delivered"`

    - `"poll.read"`

    - `"poll.updated"`

    - `"poll.vote.added"`

    - `"poll.vote.removed"`

    - `"poll.reaction.added"`

    - `"participant.added"`

    - `"participant.removed"`

    - `"chat.created"`

    - `"chat.group_name_updated"`

    - `"chat.group_icon_updated"`

    - `"chat.group_name_update_failed"`

    - `"chat.group_icon_update_failed"`

    - `"chat.background_updated"`

    - `"chat.background_update_failed"`

    - `"chat.typing_indicator.started"`

    - `"chat.typing_indicator.stopped"`

    - `"phone_number.status_updated"`

    - `"phone_number.assigned"`

    - `"phone_number.released"`

    - `"phone_number.line_type_updated"`

    - `"contact_card.received"`

    - `"location.sharing.started"`

    - `"location.sharing.stopped"`

    - `"payment.declined"`

    - `"payment.authorized"`

    - `"connection.created"`

    - `"connection.revoked"`

    - `"zero_day_retention.updated"`

    - `"phone_number.forwarding_updated"`

    - `"environment.line_moved"`

    - `"contact_card.created"`

    - `"contact_card.updated"`

    - `"contact_card.deleted"`

    - `"api_token.created"`

    - `"api_token.renamed"`

    - `"api_token.expiry_scheduled"`

    - `"api_token.expired"`

    - `"api_token.activated"`

    - `"api_token.deleted"`

    - `"environment.created"`

    - `"environment.renamed"`

    - `"environment.deleted"`

    - `"webhook_subscription.created"`

    - `"webhook_subscription.deleted"`

    - `"webhook_subscription.target_url_changed"`

    - `"webhook_subscription.enabled"`

    - `"webhook_subscription.disabled"`

    - `"webhook_subscription.events.updated"`

    - `"webhook_subscription.phone_numbers.updated"`

    - `"webhook_subscription.routing_headers_set"`

    - `"webhook_subscription.routing_headers_cleared"`

    - `"team_member.added"`

    - `"team_member.signed_in"`

    - `"team_member.signed_out"`

  - `partner_id: string`

    Partner identifier. Present on all webhooks for cross-referencing.

  - `trace_id: string`

    Trace ID for debugging and correlation across systems.

  - `webhook_version: string`

    Date-based webhook payload version.
    Determined by the `?version=` query parameter in your webhook subscription URL.
    If no version parameter is specified, defaults based on subscription creation date.

### payment.expired

- `PaymentExpiredWebhookEvent`

  - `api_version: string`

    API version for the webhook payload format

  - `created_at: string`

    When the event was created

  - `data: Data`

    The payment request, as returned by
    `GET /v3/payment_requests/{paymentRequestId}`.

    - `id: string`

      The payment request id.

    - `amount: number`

      What was charged at checkout, in the currency's minor
      units. In `subscription` mode this is the first invoice's
      total — all items after any discounts are applied.

    - `checkout_url: string`

      URL the recipient opens to pay
      (`https://zero.linqapp.com/pay/{slug}?session=...`).

    - `created_at: string`

    - `currency: string`

    - `object: string`

    - `status: "succeeded" | "failed" | "canceled" | "expired"`

      - `"succeeded"`

      - `"failed"`

      - `"canceled"`

      - `"expired"`

    - `description?: string`

    - `discount?: Discount`

      Subscription mode — the discount Stripe applied, read back
      from the coupon. Absent when none was applied.

      - `coupon?: string`

      - `label?: string`

        Name of the coupon/promo code displayed to customers.

      - `promotion_code?: string`

    - `interval?: "day" | "week" | "month" | "year"`

      Subscription mode — how often the subscription renews.

      - `"day"`

      - `"week"`

      - `"month"`

      - `"year"`

    - `interval_count?: number`

      Subscription mode — intervals per renewal.

    - `metadata?: Record<string, string>`

    - `mode?: "payment" | "subscription"`

      Whether the request collected a one-time charge or started a subscription.

      - `"payment"`

      - `"subscription"`

    - `natural?: Natural`

      Natural-rail join keys, present when `rail: natural`.

      - `payment_request_id?: string`

        The Natural payment request (`prq_...`).

      - `transaction_id?: string`

        The settled transaction (`txn_...`).

    - `price_id?: string`

      Subscription mode — the recurring price subscribed to.

    - `quantity?: number`

      Subscription mode — units of the price subscribed to.

    - `rail?: "stripe" | "natural"`

      The rail this request settled on.

      - `"stripe"`

      - `"natural"`

    - `stripe?: Stripe`

      Ids of the Stripe objects on your connected account — join
      keys into your own Stripe Dashboard/API. Manage a
      subscription's post-checkout lifecycle with `subscription_id`.

      - `customer_id?: string`

        The Customer the request is attached to (`cus_...`).
        Always set in subscription mode; set in payment mode
        only when the request was created with a `customer_id`.

      - `payment_intent_id?: string`

        The PaymentIntent collected at checkout (`pi_...`).

      - `subscription_id?: string`

        Subscription mode — the Subscription (`sub_...`).

    - `trial_end?: string`

      Subscription mode — when the free trial ends and the first
      charge happens. On a trial request, `payment.succeeded`
      means the payment method was collected ($0 moved).

    - `updated_at?: string`

  - `event_id: string`

    Unique identifier for this event (for deduplication)

  - `event_type: "payment.succeeded" | "payment.canceled" | "payment.expired" | 66 more`

    - `"payment.succeeded"`

    - `"payment.canceled"`

    - `"payment.expired"`

    - `"message.sent"`

    - `"message.received"`

    - `"message.read"`

    - `"message.delivered"`

    - `"message.failed"`

    - `"message.edited"`

    - `"reaction.added"`

    - `"reaction.removed"`

    - `"poll.received"`

    - `"poll.failed"`

    - `"poll.sent"`

    - `"poll.delivered"`

    - `"poll.read"`

    - `"poll.updated"`

    - `"poll.vote.added"`

    - `"poll.vote.removed"`

    - `"poll.reaction.added"`

    - `"participant.added"`

    - `"participant.removed"`

    - `"chat.created"`

    - `"chat.group_name_updated"`

    - `"chat.group_icon_updated"`

    - `"chat.group_name_update_failed"`

    - `"chat.group_icon_update_failed"`

    - `"chat.background_updated"`

    - `"chat.background_update_failed"`

    - `"chat.typing_indicator.started"`

    - `"chat.typing_indicator.stopped"`

    - `"phone_number.status_updated"`

    - `"phone_number.assigned"`

    - `"phone_number.released"`

    - `"phone_number.line_type_updated"`

    - `"contact_card.received"`

    - `"location.sharing.started"`

    - `"location.sharing.stopped"`

    - `"payment.declined"`

    - `"payment.authorized"`

    - `"connection.created"`

    - `"connection.revoked"`

    - `"zero_day_retention.updated"`

    - `"phone_number.forwarding_updated"`

    - `"environment.line_moved"`

    - `"contact_card.created"`

    - `"contact_card.updated"`

    - `"contact_card.deleted"`

    - `"api_token.created"`

    - `"api_token.renamed"`

    - `"api_token.expiry_scheduled"`

    - `"api_token.expired"`

    - `"api_token.activated"`

    - `"api_token.deleted"`

    - `"environment.created"`

    - `"environment.renamed"`

    - `"environment.deleted"`

    - `"webhook_subscription.created"`

    - `"webhook_subscription.deleted"`

    - `"webhook_subscription.target_url_changed"`

    - `"webhook_subscription.enabled"`

    - `"webhook_subscription.disabled"`

    - `"webhook_subscription.events.updated"`

    - `"webhook_subscription.phone_numbers.updated"`

    - `"webhook_subscription.routing_headers_set"`

    - `"webhook_subscription.routing_headers_cleared"`

    - `"team_member.added"`

    - `"team_member.signed_in"`

    - `"team_member.signed_out"`

  - `partner_id: string`

    Partner identifier. Present on all webhooks for cross-referencing.

  - `trace_id: string`

    Trace ID for debugging and correlation across systems.

  - `webhook_version: string`

    Date-based webhook payload version.
    Determined by the `?version=` query parameter in your webhook subscription URL.
    If no version parameter is specified, defaults based on subscription creation date.

### payment.succeeded

- `PaymentSucceededWebhookEvent`

  - `api_version: string`

    API version for the webhook payload format

  - `created_at: string`

    When the event was created

  - `data: Data`

    The payment request, as returned by
    `GET /v3/payment_requests/{paymentRequestId}`.

    - `id: string`

      The payment request id.

    - `amount: number`

      What was charged at checkout, in the currency's minor
      units. In `subscription` mode this is the first invoice's
      total — all items after any discounts are applied.

    - `checkout_url: string`

      URL the recipient opens to pay
      (`https://zero.linqapp.com/pay/{slug}?session=...`).

    - `created_at: string`

    - `currency: string`

    - `object: string`

    - `status: "succeeded" | "failed" | "canceled" | "expired"`

      - `"succeeded"`

      - `"failed"`

      - `"canceled"`

      - `"expired"`

    - `description?: string`

    - `discount?: Discount`

      Subscription mode — the discount Stripe applied, read back
      from the coupon. Absent when none was applied.

      - `coupon?: string`

      - `label?: string`

        Name of the coupon/promo code displayed to customers.

      - `promotion_code?: string`

    - `interval?: "day" | "week" | "month" | "year"`

      Subscription mode — how often the subscription renews.

      - `"day"`

      - `"week"`

      - `"month"`

      - `"year"`

    - `interval_count?: number`

      Subscription mode — intervals per renewal.

    - `metadata?: Record<string, string>`

    - `mode?: "payment" | "subscription"`

      Whether the request collected a one-time charge or started a subscription.

      - `"payment"`

      - `"subscription"`

    - `natural?: Natural`

      Natural-rail join keys, present when `rail: natural`.

      - `payment_request_id?: string`

        The Natural payment request (`prq_...`).

      - `transaction_id?: string`

        The settled transaction (`txn_...`).

    - `price_id?: string`

      Subscription mode — the recurring price subscribed to.

    - `quantity?: number`

      Subscription mode — units of the price subscribed to.

    - `rail?: "stripe" | "natural"`

      The rail this request settled on.

      - `"stripe"`

      - `"natural"`

    - `stripe?: Stripe`

      Ids of the Stripe objects on your connected account — join
      keys into your own Stripe Dashboard/API. Manage a
      subscription's post-checkout lifecycle with `subscription_id`.

      - `customer_id?: string`

        The Customer the request is attached to (`cus_...`).
        Always set in subscription mode; set in payment mode
        only when the request was created with a `customer_id`.

      - `payment_intent_id?: string`

        The PaymentIntent collected at checkout (`pi_...`).

      - `subscription_id?: string`

        Subscription mode — the Subscription (`sub_...`).

    - `trial_end?: string`

      Subscription mode — when the free trial ends and the first
      charge happens. On a trial request, `payment.succeeded`
      means the payment method was collected ($0 moved).

    - `updated_at?: string`

  - `event_id: string`

    Unique identifier for this event (for deduplication)

  - `event_type: "payment.succeeded" | "payment.canceled" | "payment.expired" | 66 more`

    - `"payment.succeeded"`

    - `"payment.canceled"`

    - `"payment.expired"`

    - `"message.sent"`

    - `"message.received"`

    - `"message.read"`

    - `"message.delivered"`

    - `"message.failed"`

    - `"message.edited"`

    - `"reaction.added"`

    - `"reaction.removed"`

    - `"poll.received"`

    - `"poll.failed"`

    - `"poll.sent"`

    - `"poll.delivered"`

    - `"poll.read"`

    - `"poll.updated"`

    - `"poll.vote.added"`

    - `"poll.vote.removed"`

    - `"poll.reaction.added"`

    - `"participant.added"`

    - `"participant.removed"`

    - `"chat.created"`

    - `"chat.group_name_updated"`

    - `"chat.group_icon_updated"`

    - `"chat.group_name_update_failed"`

    - `"chat.group_icon_update_failed"`

    - `"chat.background_updated"`

    - `"chat.background_update_failed"`

    - `"chat.typing_indicator.started"`

    - `"chat.typing_indicator.stopped"`

    - `"phone_number.status_updated"`

    - `"phone_number.assigned"`

    - `"phone_number.released"`

    - `"phone_number.line_type_updated"`

    - `"contact_card.received"`

    - `"location.sharing.started"`

    - `"location.sharing.stopped"`

    - `"payment.declined"`

    - `"payment.authorized"`

    - `"connection.created"`

    - `"connection.revoked"`

    - `"zero_day_retention.updated"`

    - `"phone_number.forwarding_updated"`

    - `"environment.line_moved"`

    - `"contact_card.created"`

    - `"contact_card.updated"`

    - `"contact_card.deleted"`

    - `"api_token.created"`

    - `"api_token.renamed"`

    - `"api_token.expiry_scheduled"`

    - `"api_token.expired"`

    - `"api_token.activated"`

    - `"api_token.deleted"`

    - `"environment.created"`

    - `"environment.renamed"`

    - `"environment.deleted"`

    - `"webhook_subscription.created"`

    - `"webhook_subscription.deleted"`

    - `"webhook_subscription.target_url_changed"`

    - `"webhook_subscription.enabled"`

    - `"webhook_subscription.disabled"`

    - `"webhook_subscription.events.updated"`

    - `"webhook_subscription.phone_numbers.updated"`

    - `"webhook_subscription.routing_headers_set"`

    - `"webhook_subscription.routing_headers_cleared"`

    - `"team_member.added"`

    - `"team_member.signed_in"`

    - `"team_member.signed_out"`

  - `partner_id: string`

    Partner identifier. Present on all webhooks for cross-referencing.

  - `trace_id: string`

    Trace ID for debugging and correlation across systems.

  - `webhook_version: string`

    Date-based webhook payload version.
    Determined by the `?version=` query parameter in your webhook subscription URL.
    If no version parameter is specified, defaults based on subscription creation date.

### Unwrap Webhook Event

- `UnwrapWebhookEvent = ConnectionCreatedWebhookEvent | ConnectionRevokedWebhookEvent | PaymentAuthorizedWebhookEvent | 4 more`

  - `ConnectionCreatedWebhookEvent`

    - `api_version: string`

      API version for the webhook payload format

    - `created_at: string`

      When the event was created

    - `data: Data`

      The payment request, as returned by
      `GET /v3/payment_requests/{paymentRequestId}`.

      - `id: string`

        The payment request id.

      - `amount: number`

        What was charged at checkout, in the currency's minor
        units. In `subscription` mode this is the first invoice's
        total — all items after any discounts are applied.

      - `checkout_url: string`

        URL the recipient opens to pay
        (`https://zero.linqapp.com/pay/{slug}?session=...`).

      - `created_at: string`

      - `currency: string`

      - `object: string`

      - `status: "succeeded" | "failed" | "canceled" | "expired"`

        - `"succeeded"`

        - `"failed"`

        - `"canceled"`

        - `"expired"`

      - `description?: string`

      - `discount?: Discount`

        Subscription mode — the discount Stripe applied, read back
        from the coupon. Absent when none was applied.

        - `coupon?: string`

        - `label?: string`

          Name of the coupon/promo code displayed to customers.

        - `promotion_code?: string`

      - `interval?: "day" | "week" | "month" | "year"`

        Subscription mode — how often the subscription renews.

        - `"day"`

        - `"week"`

        - `"month"`

        - `"year"`

      - `interval_count?: number`

        Subscription mode — intervals per renewal.

      - `metadata?: Record<string, string>`

      - `mode?: "payment" | "subscription"`

        Whether the request collected a one-time charge or started a subscription.

        - `"payment"`

        - `"subscription"`

      - `natural?: Natural`

        Natural-rail join keys, present when `rail: natural`.

        - `payment_request_id?: string`

          The Natural payment request (`prq_...`).

        - `transaction_id?: string`

          The settled transaction (`txn_...`).

      - `price_id?: string`

        Subscription mode — the recurring price subscribed to.

      - `quantity?: number`

        Subscription mode — units of the price subscribed to.

      - `rail?: "stripe" | "natural"`

        The rail this request settled on.

        - `"stripe"`

        - `"natural"`

      - `stripe?: Stripe`

        Ids of the Stripe objects on your connected account — join
        keys into your own Stripe Dashboard/API. Manage a
        subscription's post-checkout lifecycle with `subscription_id`.

        - `customer_id?: string`

          The Customer the request is attached to (`cus_...`).
          Always set in subscription mode; set in payment mode
          only when the request was created with a `customer_id`.

        - `payment_intent_id?: string`

          The PaymentIntent collected at checkout (`pi_...`).

        - `subscription_id?: string`

          Subscription mode — the Subscription (`sub_...`).

      - `trial_end?: string`

        Subscription mode — when the free trial ends and the first
        charge happens. On a trial request, `payment.succeeded`
        means the payment method was collected ($0 moved).

      - `updated_at?: string`

    - `event_id: string`

      Unique identifier for this event (for deduplication)

    - `event_type: "payment.succeeded" | "payment.canceled" | "payment.expired" | 66 more`

      - `"payment.succeeded"`

      - `"payment.canceled"`

      - `"payment.expired"`

      - `"message.sent"`

      - `"message.received"`

      - `"message.read"`

      - `"message.delivered"`

      - `"message.failed"`

      - `"message.edited"`

      - `"reaction.added"`

      - `"reaction.removed"`

      - `"poll.received"`

      - `"poll.failed"`

      - `"poll.sent"`

      - `"poll.delivered"`

      - `"poll.read"`

      - `"poll.updated"`

      - `"poll.vote.added"`

      - `"poll.vote.removed"`

      - `"poll.reaction.added"`

      - `"participant.added"`

      - `"participant.removed"`

      - `"chat.created"`

      - `"chat.group_name_updated"`

      - `"chat.group_icon_updated"`

      - `"chat.group_name_update_failed"`

      - `"chat.group_icon_update_failed"`

      - `"chat.background_updated"`

      - `"chat.background_update_failed"`

      - `"chat.typing_indicator.started"`

      - `"chat.typing_indicator.stopped"`

      - `"phone_number.status_updated"`

      - `"phone_number.assigned"`

      - `"phone_number.released"`

      - `"phone_number.line_type_updated"`

      - `"contact_card.received"`

      - `"location.sharing.started"`

      - `"location.sharing.stopped"`

      - `"payment.declined"`

      - `"payment.authorized"`

      - `"connection.created"`

      - `"connection.revoked"`

      - `"zero_day_retention.updated"`

      - `"phone_number.forwarding_updated"`

      - `"environment.line_moved"`

      - `"contact_card.created"`

      - `"contact_card.updated"`

      - `"contact_card.deleted"`

      - `"api_token.created"`

      - `"api_token.renamed"`

      - `"api_token.expiry_scheduled"`

      - `"api_token.expired"`

      - `"api_token.activated"`

      - `"api_token.deleted"`

      - `"environment.created"`

      - `"environment.renamed"`

      - `"environment.deleted"`

      - `"webhook_subscription.created"`

      - `"webhook_subscription.deleted"`

      - `"webhook_subscription.target_url_changed"`

      - `"webhook_subscription.enabled"`

      - `"webhook_subscription.disabled"`

      - `"webhook_subscription.events.updated"`

      - `"webhook_subscription.phone_numbers.updated"`

      - `"webhook_subscription.routing_headers_set"`

      - `"webhook_subscription.routing_headers_cleared"`

      - `"team_member.added"`

      - `"team_member.signed_in"`

      - `"team_member.signed_out"`

    - `partner_id: string`

      Partner identifier. Present on all webhooks for cross-referencing.

    - `trace_id: string`

      Trace ID for debugging and correlation across systems.

    - `webhook_version: string`

      Date-based webhook payload version.
      Determined by the `?version=` query parameter in your webhook subscription URL.
      If no version parameter is specified, defaults based on subscription creation date.

  - `ConnectionRevokedWebhookEvent`

    - `api_version: string`

      API version for the webhook payload format

    - `created_at: string`

      When the event was created

    - `data: Data`

      The payment request, as returned by
      `GET /v3/payment_requests/{paymentRequestId}`.

      - `id: string`

        The payment request id.

      - `amount: number`

        What was charged at checkout, in the currency's minor
        units. In `subscription` mode this is the first invoice's
        total — all items after any discounts are applied.

      - `checkout_url: string`

        URL the recipient opens to pay
        (`https://zero.linqapp.com/pay/{slug}?session=...`).

      - `created_at: string`

      - `currency: string`

      - `object: string`

      - `status: "succeeded" | "failed" | "canceled" | "expired"`

        - `"succeeded"`

        - `"failed"`

        - `"canceled"`

        - `"expired"`

      - `description?: string`

      - `discount?: Discount`

        Subscription mode — the discount Stripe applied, read back
        from the coupon. Absent when none was applied.

        - `coupon?: string`

        - `label?: string`

          Name of the coupon/promo code displayed to customers.

        - `promotion_code?: string`

      - `interval?: "day" | "week" | "month" | "year"`

        Subscription mode — how often the subscription renews.

        - `"day"`

        - `"week"`

        - `"month"`

        - `"year"`

      - `interval_count?: number`

        Subscription mode — intervals per renewal.

      - `metadata?: Record<string, string>`

      - `mode?: "payment" | "subscription"`

        Whether the request collected a one-time charge or started a subscription.

        - `"payment"`

        - `"subscription"`

      - `natural?: Natural`

        Natural-rail join keys, present when `rail: natural`.

        - `payment_request_id?: string`

          The Natural payment request (`prq_...`).

        - `transaction_id?: string`

          The settled transaction (`txn_...`).

      - `price_id?: string`

        Subscription mode — the recurring price subscribed to.

      - `quantity?: number`

        Subscription mode — units of the price subscribed to.

      - `rail?: "stripe" | "natural"`

        The rail this request settled on.

        - `"stripe"`

        - `"natural"`

      - `stripe?: Stripe`

        Ids of the Stripe objects on your connected account — join
        keys into your own Stripe Dashboard/API. Manage a
        subscription's post-checkout lifecycle with `subscription_id`.

        - `customer_id?: string`

          The Customer the request is attached to (`cus_...`).
          Always set in subscription mode; set in payment mode
          only when the request was created with a `customer_id`.

        - `payment_intent_id?: string`

          The PaymentIntent collected at checkout (`pi_...`).

        - `subscription_id?: string`

          Subscription mode — the Subscription (`sub_...`).

      - `trial_end?: string`

        Subscription mode — when the free trial ends and the first
        charge happens. On a trial request, `payment.succeeded`
        means the payment method was collected ($0 moved).

      - `updated_at?: string`

    - `event_id: string`

      Unique identifier for this event (for deduplication)

    - `event_type: "payment.succeeded" | "payment.canceled" | "payment.expired" | 66 more`

      - `"payment.succeeded"`

      - `"payment.canceled"`

      - `"payment.expired"`

      - `"message.sent"`

      - `"message.received"`

      - `"message.read"`

      - `"message.delivered"`

      - `"message.failed"`

      - `"message.edited"`

      - `"reaction.added"`

      - `"reaction.removed"`

      - `"poll.received"`

      - `"poll.failed"`

      - `"poll.sent"`

      - `"poll.delivered"`

      - `"poll.read"`

      - `"poll.updated"`

      - `"poll.vote.added"`

      - `"poll.vote.removed"`

      - `"poll.reaction.added"`

      - `"participant.added"`

      - `"participant.removed"`

      - `"chat.created"`

      - `"chat.group_name_updated"`

      - `"chat.group_icon_updated"`

      - `"chat.group_name_update_failed"`

      - `"chat.group_icon_update_failed"`

      - `"chat.background_updated"`

      - `"chat.background_update_failed"`

      - `"chat.typing_indicator.started"`

      - `"chat.typing_indicator.stopped"`

      - `"phone_number.status_updated"`

      - `"phone_number.assigned"`

      - `"phone_number.released"`

      - `"phone_number.line_type_updated"`

      - `"contact_card.received"`

      - `"location.sharing.started"`

      - `"location.sharing.stopped"`

      - `"payment.declined"`

      - `"payment.authorized"`

      - `"connection.created"`

      - `"connection.revoked"`

      - `"zero_day_retention.updated"`

      - `"phone_number.forwarding_updated"`

      - `"environment.line_moved"`

      - `"contact_card.created"`

      - `"contact_card.updated"`

      - `"contact_card.deleted"`

      - `"api_token.created"`

      - `"api_token.renamed"`

      - `"api_token.expiry_scheduled"`

      - `"api_token.expired"`

      - `"api_token.activated"`

      - `"api_token.deleted"`

      - `"environment.created"`

      - `"environment.renamed"`

      - `"environment.deleted"`

      - `"webhook_subscription.created"`

      - `"webhook_subscription.deleted"`

      - `"webhook_subscription.target_url_changed"`

      - `"webhook_subscription.enabled"`

      - `"webhook_subscription.disabled"`

      - `"webhook_subscription.events.updated"`

      - `"webhook_subscription.phone_numbers.updated"`

      - `"webhook_subscription.routing_headers_set"`

      - `"webhook_subscription.routing_headers_cleared"`

      - `"team_member.added"`

      - `"team_member.signed_in"`

      - `"team_member.signed_out"`

    - `partner_id: string`

      Partner identifier. Present on all webhooks for cross-referencing.

    - `trace_id: string`

      Trace ID for debugging and correlation across systems.

    - `webhook_version: string`

      Date-based webhook payload version.
      Determined by the `?version=` query parameter in your webhook subscription URL.
      If no version parameter is specified, defaults based on subscription creation date.

  - `PaymentAuthorizedWebhookEvent`

    - `api_version: string`

      API version for the webhook payload format

    - `created_at: string`

      When the event was created

    - `data: Data`

      The payment request, as returned by
      `GET /v3/payment_requests/{paymentRequestId}`.

      - `id: string`

        The payment request id.

      - `amount: number`

        What was charged at checkout, in the currency's minor
        units. In `subscription` mode this is the first invoice's
        total — all items after any discounts are applied.

      - `checkout_url: string`

        URL the recipient opens to pay
        (`https://zero.linqapp.com/pay/{slug}?session=...`).

      - `created_at: string`

      - `currency: string`

      - `object: string`

      - `status: "succeeded" | "failed" | "canceled" | "expired"`

        - `"succeeded"`

        - `"failed"`

        - `"canceled"`

        - `"expired"`

      - `description?: string`

      - `discount?: Discount`

        Subscription mode — the discount Stripe applied, read back
        from the coupon. Absent when none was applied.

        - `coupon?: string`

        - `label?: string`

          Name of the coupon/promo code displayed to customers.

        - `promotion_code?: string`

      - `interval?: "day" | "week" | "month" | "year"`

        Subscription mode — how often the subscription renews.

        - `"day"`

        - `"week"`

        - `"month"`

        - `"year"`

      - `interval_count?: number`

        Subscription mode — intervals per renewal.

      - `metadata?: Record<string, string>`

      - `mode?: "payment" | "subscription"`

        Whether the request collected a one-time charge or started a subscription.

        - `"payment"`

        - `"subscription"`

      - `natural?: Natural`

        Natural-rail join keys, present when `rail: natural`.

        - `payment_request_id?: string`

          The Natural payment request (`prq_...`).

        - `transaction_id?: string`

          The settled transaction (`txn_...`).

      - `price_id?: string`

        Subscription mode — the recurring price subscribed to.

      - `quantity?: number`

        Subscription mode — units of the price subscribed to.

      - `rail?: "stripe" | "natural"`

        The rail this request settled on.

        - `"stripe"`

        - `"natural"`

      - `stripe?: Stripe`

        Ids of the Stripe objects on your connected account — join
        keys into your own Stripe Dashboard/API. Manage a
        subscription's post-checkout lifecycle with `subscription_id`.

        - `customer_id?: string`

          The Customer the request is attached to (`cus_...`).
          Always set in subscription mode; set in payment mode
          only when the request was created with a `customer_id`.

        - `payment_intent_id?: string`

          The PaymentIntent collected at checkout (`pi_...`).

        - `subscription_id?: string`

          Subscription mode — the Subscription (`sub_...`).

      - `trial_end?: string`

        Subscription mode — when the free trial ends and the first
        charge happens. On a trial request, `payment.succeeded`
        means the payment method was collected ($0 moved).

      - `updated_at?: string`

    - `event_id: string`

      Unique identifier for this event (for deduplication)

    - `event_type: "payment.succeeded" | "payment.canceled" | "payment.expired" | 66 more`

      - `"payment.succeeded"`

      - `"payment.canceled"`

      - `"payment.expired"`

      - `"message.sent"`

      - `"message.received"`

      - `"message.read"`

      - `"message.delivered"`

      - `"message.failed"`

      - `"message.edited"`

      - `"reaction.added"`

      - `"reaction.removed"`

      - `"poll.received"`

      - `"poll.failed"`

      - `"poll.sent"`

      - `"poll.delivered"`

      - `"poll.read"`

      - `"poll.updated"`

      - `"poll.vote.added"`

      - `"poll.vote.removed"`

      - `"poll.reaction.added"`

      - `"participant.added"`

      - `"participant.removed"`

      - `"chat.created"`

      - `"chat.group_name_updated"`

      - `"chat.group_icon_updated"`

      - `"chat.group_name_update_failed"`

      - `"chat.group_icon_update_failed"`

      - `"chat.background_updated"`

      - `"chat.background_update_failed"`

      - `"chat.typing_indicator.started"`

      - `"chat.typing_indicator.stopped"`

      - `"phone_number.status_updated"`

      - `"phone_number.assigned"`

      - `"phone_number.released"`

      - `"phone_number.line_type_updated"`

      - `"contact_card.received"`

      - `"location.sharing.started"`

      - `"location.sharing.stopped"`

      - `"payment.declined"`

      - `"payment.authorized"`

      - `"connection.created"`

      - `"connection.revoked"`

      - `"zero_day_retention.updated"`

      - `"phone_number.forwarding_updated"`

      - `"environment.line_moved"`

      - `"contact_card.created"`

      - `"contact_card.updated"`

      - `"contact_card.deleted"`

      - `"api_token.created"`

      - `"api_token.renamed"`

      - `"api_token.expiry_scheduled"`

      - `"api_token.expired"`

      - `"api_token.activated"`

      - `"api_token.deleted"`

      - `"environment.created"`

      - `"environment.renamed"`

      - `"environment.deleted"`

      - `"webhook_subscription.created"`

      - `"webhook_subscription.deleted"`

      - `"webhook_subscription.target_url_changed"`

      - `"webhook_subscription.enabled"`

      - `"webhook_subscription.disabled"`

      - `"webhook_subscription.events.updated"`

      - `"webhook_subscription.phone_numbers.updated"`

      - `"webhook_subscription.routing_headers_set"`

      - `"webhook_subscription.routing_headers_cleared"`

      - `"team_member.added"`

      - `"team_member.signed_in"`

      - `"team_member.signed_out"`

    - `partner_id: string`

      Partner identifier. Present on all webhooks for cross-referencing.

    - `trace_id: string`

      Trace ID for debugging and correlation across systems.

    - `webhook_version: string`

      Date-based webhook payload version.
      Determined by the `?version=` query parameter in your webhook subscription URL.
      If no version parameter is specified, defaults based on subscription creation date.

  - `PaymentCanceledWebhookEvent`

    - `api_version: string`

      API version for the webhook payload format

    - `created_at: string`

      When the event was created

    - `data: Data`

      The payment request, as returned by
      `GET /v3/payment_requests/{paymentRequestId}`.

      - `id: string`

        The payment request id.

      - `amount: number`

        What was charged at checkout, in the currency's minor
        units. In `subscription` mode this is the first invoice's
        total — all items after any discounts are applied.

      - `checkout_url: string`

        URL the recipient opens to pay
        (`https://zero.linqapp.com/pay/{slug}?session=...`).

      - `created_at: string`

      - `currency: string`

      - `object: string`

      - `status: "succeeded" | "failed" | "canceled" | "expired"`

        - `"succeeded"`

        - `"failed"`

        - `"canceled"`

        - `"expired"`

      - `description?: string`

      - `discount?: Discount`

        Subscription mode — the discount Stripe applied, read back
        from the coupon. Absent when none was applied.

        - `coupon?: string`

        - `label?: string`

          Name of the coupon/promo code displayed to customers.

        - `promotion_code?: string`

      - `interval?: "day" | "week" | "month" | "year"`

        Subscription mode — how often the subscription renews.

        - `"day"`

        - `"week"`

        - `"month"`

        - `"year"`

      - `interval_count?: number`

        Subscription mode — intervals per renewal.

      - `metadata?: Record<string, string>`

      - `mode?: "payment" | "subscription"`

        Whether the request collected a one-time charge or started a subscription.

        - `"payment"`

        - `"subscription"`

      - `natural?: Natural`

        Natural-rail join keys, present when `rail: natural`.

        - `payment_request_id?: string`

          The Natural payment request (`prq_...`).

        - `transaction_id?: string`

          The settled transaction (`txn_...`).

      - `price_id?: string`

        Subscription mode — the recurring price subscribed to.

      - `quantity?: number`

        Subscription mode — units of the price subscribed to.

      - `rail?: "stripe" | "natural"`

        The rail this request settled on.

        - `"stripe"`

        - `"natural"`

      - `stripe?: Stripe`

        Ids of the Stripe objects on your connected account — join
        keys into your own Stripe Dashboard/API. Manage a
        subscription's post-checkout lifecycle with `subscription_id`.

        - `customer_id?: string`

          The Customer the request is attached to (`cus_...`).
          Always set in subscription mode; set in payment mode
          only when the request was created with a `customer_id`.

        - `payment_intent_id?: string`

          The PaymentIntent collected at checkout (`pi_...`).

        - `subscription_id?: string`

          Subscription mode — the Subscription (`sub_...`).

      - `trial_end?: string`

        Subscription mode — when the free trial ends and the first
        charge happens. On a trial request, `payment.succeeded`
        means the payment method was collected ($0 moved).

      - `updated_at?: string`

    - `event_id: string`

      Unique identifier for this event (for deduplication)

    - `event_type: "payment.succeeded" | "payment.canceled" | "payment.expired" | 66 more`

      - `"payment.succeeded"`

      - `"payment.canceled"`

      - `"payment.expired"`

      - `"message.sent"`

      - `"message.received"`

      - `"message.read"`

      - `"message.delivered"`

      - `"message.failed"`

      - `"message.edited"`

      - `"reaction.added"`

      - `"reaction.removed"`

      - `"poll.received"`

      - `"poll.failed"`

      - `"poll.sent"`

      - `"poll.delivered"`

      - `"poll.read"`

      - `"poll.updated"`

      - `"poll.vote.added"`

      - `"poll.vote.removed"`

      - `"poll.reaction.added"`

      - `"participant.added"`

      - `"participant.removed"`

      - `"chat.created"`

      - `"chat.group_name_updated"`

      - `"chat.group_icon_updated"`

      - `"chat.group_name_update_failed"`

      - `"chat.group_icon_update_failed"`

      - `"chat.background_updated"`

      - `"chat.background_update_failed"`

      - `"chat.typing_indicator.started"`

      - `"chat.typing_indicator.stopped"`

      - `"phone_number.status_updated"`

      - `"phone_number.assigned"`

      - `"phone_number.released"`

      - `"phone_number.line_type_updated"`

      - `"contact_card.received"`

      - `"location.sharing.started"`

      - `"location.sharing.stopped"`

      - `"payment.declined"`

      - `"payment.authorized"`

      - `"connection.created"`

      - `"connection.revoked"`

      - `"zero_day_retention.updated"`

      - `"phone_number.forwarding_updated"`

      - `"environment.line_moved"`

      - `"contact_card.created"`

      - `"contact_card.updated"`

      - `"contact_card.deleted"`

      - `"api_token.created"`

      - `"api_token.renamed"`

      - `"api_token.expiry_scheduled"`

      - `"api_token.expired"`

      - `"api_token.activated"`

      - `"api_token.deleted"`

      - `"environment.created"`

      - `"environment.renamed"`

      - `"environment.deleted"`

      - `"webhook_subscription.created"`

      - `"webhook_subscription.deleted"`

      - `"webhook_subscription.target_url_changed"`

      - `"webhook_subscription.enabled"`

      - `"webhook_subscription.disabled"`

      - `"webhook_subscription.events.updated"`

      - `"webhook_subscription.phone_numbers.updated"`

      - `"webhook_subscription.routing_headers_set"`

      - `"webhook_subscription.routing_headers_cleared"`

      - `"team_member.added"`

      - `"team_member.signed_in"`

      - `"team_member.signed_out"`

    - `partner_id: string`

      Partner identifier. Present on all webhooks for cross-referencing.

    - `trace_id: string`

      Trace ID for debugging and correlation across systems.

    - `webhook_version: string`

      Date-based webhook payload version.
      Determined by the `?version=` query parameter in your webhook subscription URL.
      If no version parameter is specified, defaults based on subscription creation date.

  - `PaymentDeclinedWebhookEvent`

    - `api_version: string`

      API version for the webhook payload format

    - `created_at: string`

      When the event was created

    - `data: Data`

      The payment request, as returned by
      `GET /v3/payment_requests/{paymentRequestId}`.

      - `id: string`

        The payment request id.

      - `amount: number`

        What was charged at checkout, in the currency's minor
        units. In `subscription` mode this is the first invoice's
        total — all items after any discounts are applied.

      - `checkout_url: string`

        URL the recipient opens to pay
        (`https://zero.linqapp.com/pay/{slug}?session=...`).

      - `created_at: string`

      - `currency: string`

      - `object: string`

      - `status: "succeeded" | "failed" | "canceled" | "expired"`

        - `"succeeded"`

        - `"failed"`

        - `"canceled"`

        - `"expired"`

      - `description?: string`

      - `discount?: Discount`

        Subscription mode — the discount Stripe applied, read back
        from the coupon. Absent when none was applied.

        - `coupon?: string`

        - `label?: string`

          Name of the coupon/promo code displayed to customers.

        - `promotion_code?: string`

      - `interval?: "day" | "week" | "month" | "year"`

        Subscription mode — how often the subscription renews.

        - `"day"`

        - `"week"`

        - `"month"`

        - `"year"`

      - `interval_count?: number`

        Subscription mode — intervals per renewal.

      - `metadata?: Record<string, string>`

      - `mode?: "payment" | "subscription"`

        Whether the request collected a one-time charge or started a subscription.

        - `"payment"`

        - `"subscription"`

      - `natural?: Natural`

        Natural-rail join keys, present when `rail: natural`.

        - `payment_request_id?: string`

          The Natural payment request (`prq_...`).

        - `transaction_id?: string`

          The settled transaction (`txn_...`).

      - `price_id?: string`

        Subscription mode — the recurring price subscribed to.

      - `quantity?: number`

        Subscription mode — units of the price subscribed to.

      - `rail?: "stripe" | "natural"`

        The rail this request settled on.

        - `"stripe"`

        - `"natural"`

      - `stripe?: Stripe`

        Ids of the Stripe objects on your connected account — join
        keys into your own Stripe Dashboard/API. Manage a
        subscription's post-checkout lifecycle with `subscription_id`.

        - `customer_id?: string`

          The Customer the request is attached to (`cus_...`).
          Always set in subscription mode; set in payment mode
          only when the request was created with a `customer_id`.

        - `payment_intent_id?: string`

          The PaymentIntent collected at checkout (`pi_...`).

        - `subscription_id?: string`

          Subscription mode — the Subscription (`sub_...`).

      - `trial_end?: string`

        Subscription mode — when the free trial ends and the first
        charge happens. On a trial request, `payment.succeeded`
        means the payment method was collected ($0 moved).

      - `updated_at?: string`

    - `event_id: string`

      Unique identifier for this event (for deduplication)

    - `event_type: "payment.succeeded" | "payment.canceled" | "payment.expired" | 66 more`

      - `"payment.succeeded"`

      - `"payment.canceled"`

      - `"payment.expired"`

      - `"message.sent"`

      - `"message.received"`

      - `"message.read"`

      - `"message.delivered"`

      - `"message.failed"`

      - `"message.edited"`

      - `"reaction.added"`

      - `"reaction.removed"`

      - `"poll.received"`

      - `"poll.failed"`

      - `"poll.sent"`

      - `"poll.delivered"`

      - `"poll.read"`

      - `"poll.updated"`

      - `"poll.vote.added"`

      - `"poll.vote.removed"`

      - `"poll.reaction.added"`

      - `"participant.added"`

      - `"participant.removed"`

      - `"chat.created"`

      - `"chat.group_name_updated"`

      - `"chat.group_icon_updated"`

      - `"chat.group_name_update_failed"`

      - `"chat.group_icon_update_failed"`

      - `"chat.background_updated"`

      - `"chat.background_update_failed"`

      - `"chat.typing_indicator.started"`

      - `"chat.typing_indicator.stopped"`

      - `"phone_number.status_updated"`

      - `"phone_number.assigned"`

      - `"phone_number.released"`

      - `"phone_number.line_type_updated"`

      - `"contact_card.received"`

      - `"location.sharing.started"`

      - `"location.sharing.stopped"`

      - `"payment.declined"`

      - `"payment.authorized"`

      - `"connection.created"`

      - `"connection.revoked"`

      - `"zero_day_retention.updated"`

      - `"phone_number.forwarding_updated"`

      - `"environment.line_moved"`

      - `"contact_card.created"`

      - `"contact_card.updated"`

      - `"contact_card.deleted"`

      - `"api_token.created"`

      - `"api_token.renamed"`

      - `"api_token.expiry_scheduled"`

      - `"api_token.expired"`

      - `"api_token.activated"`

      - `"api_token.deleted"`

      - `"environment.created"`

      - `"environment.renamed"`

      - `"environment.deleted"`

      - `"webhook_subscription.created"`

      - `"webhook_subscription.deleted"`

      - `"webhook_subscription.target_url_changed"`

      - `"webhook_subscription.enabled"`

      - `"webhook_subscription.disabled"`

      - `"webhook_subscription.events.updated"`

      - `"webhook_subscription.phone_numbers.updated"`

      - `"webhook_subscription.routing_headers_set"`

      - `"webhook_subscription.routing_headers_cleared"`

      - `"team_member.added"`

      - `"team_member.signed_in"`

      - `"team_member.signed_out"`

    - `partner_id: string`

      Partner identifier. Present on all webhooks for cross-referencing.

    - `trace_id: string`

      Trace ID for debugging and correlation across systems.

    - `webhook_version: string`

      Date-based webhook payload version.
      Determined by the `?version=` query parameter in your webhook subscription URL.
      If no version parameter is specified, defaults based on subscription creation date.

  - `PaymentExpiredWebhookEvent`

    - `api_version: string`

      API version for the webhook payload format

    - `created_at: string`

      When the event was created

    - `data: Data`

      The payment request, as returned by
      `GET /v3/payment_requests/{paymentRequestId}`.

      - `id: string`

        The payment request id.

      - `amount: number`

        What was charged at checkout, in the currency's minor
        units. In `subscription` mode this is the first invoice's
        total — all items after any discounts are applied.

      - `checkout_url: string`

        URL the recipient opens to pay
        (`https://zero.linqapp.com/pay/{slug}?session=...`).

      - `created_at: string`

      - `currency: string`

      - `object: string`

      - `status: "succeeded" | "failed" | "canceled" | "expired"`

        - `"succeeded"`

        - `"failed"`

        - `"canceled"`

        - `"expired"`

      - `description?: string`

      - `discount?: Discount`

        Subscription mode — the discount Stripe applied, read back
        from the coupon. Absent when none was applied.

        - `coupon?: string`

        - `label?: string`

          Name of the coupon/promo code displayed to customers.

        - `promotion_code?: string`

      - `interval?: "day" | "week" | "month" | "year"`

        Subscription mode — how often the subscription renews.

        - `"day"`

        - `"week"`

        - `"month"`

        - `"year"`

      - `interval_count?: number`

        Subscription mode — intervals per renewal.

      - `metadata?: Record<string, string>`

      - `mode?: "payment" | "subscription"`

        Whether the request collected a one-time charge or started a subscription.

        - `"payment"`

        - `"subscription"`

      - `natural?: Natural`

        Natural-rail join keys, present when `rail: natural`.

        - `payment_request_id?: string`

          The Natural payment request (`prq_...`).

        - `transaction_id?: string`

          The settled transaction (`txn_...`).

      - `price_id?: string`

        Subscription mode — the recurring price subscribed to.

      - `quantity?: number`

        Subscription mode — units of the price subscribed to.

      - `rail?: "stripe" | "natural"`

        The rail this request settled on.

        - `"stripe"`

        - `"natural"`

      - `stripe?: Stripe`

        Ids of the Stripe objects on your connected account — join
        keys into your own Stripe Dashboard/API. Manage a
        subscription's post-checkout lifecycle with `subscription_id`.

        - `customer_id?: string`

          The Customer the request is attached to (`cus_...`).
          Always set in subscription mode; set in payment mode
          only when the request was created with a `customer_id`.

        - `payment_intent_id?: string`

          The PaymentIntent collected at checkout (`pi_...`).

        - `subscription_id?: string`

          Subscription mode — the Subscription (`sub_...`).

      - `trial_end?: string`

        Subscription mode — when the free trial ends and the first
        charge happens. On a trial request, `payment.succeeded`
        means the payment method was collected ($0 moved).

      - `updated_at?: string`

    - `event_id: string`

      Unique identifier for this event (for deduplication)

    - `event_type: "payment.succeeded" | "payment.canceled" | "payment.expired" | 66 more`

      - `"payment.succeeded"`

      - `"payment.canceled"`

      - `"payment.expired"`

      - `"message.sent"`

      - `"message.received"`

      - `"message.read"`

      - `"message.delivered"`

      - `"message.failed"`

      - `"message.edited"`

      - `"reaction.added"`

      - `"reaction.removed"`

      - `"poll.received"`

      - `"poll.failed"`

      - `"poll.sent"`

      - `"poll.delivered"`

      - `"poll.read"`

      - `"poll.updated"`

      - `"poll.vote.added"`

      - `"poll.vote.removed"`

      - `"poll.reaction.added"`

      - `"participant.added"`

      - `"participant.removed"`

      - `"chat.created"`

      - `"chat.group_name_updated"`

      - `"chat.group_icon_updated"`

      - `"chat.group_name_update_failed"`

      - `"chat.group_icon_update_failed"`

      - `"chat.background_updated"`

      - `"chat.background_update_failed"`

      - `"chat.typing_indicator.started"`

      - `"chat.typing_indicator.stopped"`

      - `"phone_number.status_updated"`

      - `"phone_number.assigned"`

      - `"phone_number.released"`

      - `"phone_number.line_type_updated"`

      - `"contact_card.received"`

      - `"location.sharing.started"`

      - `"location.sharing.stopped"`

      - `"payment.declined"`

      - `"payment.authorized"`

      - `"connection.created"`

      - `"connection.revoked"`

      - `"zero_day_retention.updated"`

      - `"phone_number.forwarding_updated"`

      - `"environment.line_moved"`

      - `"contact_card.created"`

      - `"contact_card.updated"`

      - `"contact_card.deleted"`

      - `"api_token.created"`

      - `"api_token.renamed"`

      - `"api_token.expiry_scheduled"`

      - `"api_token.expired"`

      - `"api_token.activated"`

      - `"api_token.deleted"`

      - `"environment.created"`

      - `"environment.renamed"`

      - `"environment.deleted"`

      - `"webhook_subscription.created"`

      - `"webhook_subscription.deleted"`

      - `"webhook_subscription.target_url_changed"`

      - `"webhook_subscription.enabled"`

      - `"webhook_subscription.disabled"`

      - `"webhook_subscription.events.updated"`

      - `"webhook_subscription.phone_numbers.updated"`

      - `"webhook_subscription.routing_headers_set"`

      - `"webhook_subscription.routing_headers_cleared"`

      - `"team_member.added"`

      - `"team_member.signed_in"`

      - `"team_member.signed_out"`

    - `partner_id: string`

      Partner identifier. Present on all webhooks for cross-referencing.

    - `trace_id: string`

      Trace ID for debugging and correlation across systems.

    - `webhook_version: string`

      Date-based webhook payload version.
      Determined by the `?version=` query parameter in your webhook subscription URL.
      If no version parameter is specified, defaults based on subscription creation date.

  - `PaymentSucceededWebhookEvent`

    - `api_version: string`

      API version for the webhook payload format

    - `created_at: string`

      When the event was created

    - `data: Data`

      The payment request, as returned by
      `GET /v3/payment_requests/{paymentRequestId}`.

      - `id: string`

        The payment request id.

      - `amount: number`

        What was charged at checkout, in the currency's minor
        units. In `subscription` mode this is the first invoice's
        total — all items after any discounts are applied.

      - `checkout_url: string`

        URL the recipient opens to pay
        (`https://zero.linqapp.com/pay/{slug}?session=...`).

      - `created_at: string`

      - `currency: string`

      - `object: string`

      - `status: "succeeded" | "failed" | "canceled" | "expired"`

        - `"succeeded"`

        - `"failed"`

        - `"canceled"`

        - `"expired"`

      - `description?: string`

      - `discount?: Discount`

        Subscription mode — the discount Stripe applied, read back
        from the coupon. Absent when none was applied.

        - `coupon?: string`

        - `label?: string`

          Name of the coupon/promo code displayed to customers.

        - `promotion_code?: string`

      - `interval?: "day" | "week" | "month" | "year"`

        Subscription mode — how often the subscription renews.

        - `"day"`

        - `"week"`

        - `"month"`

        - `"year"`

      - `interval_count?: number`

        Subscription mode — intervals per renewal.

      - `metadata?: Record<string, string>`

      - `mode?: "payment" | "subscription"`

        Whether the request collected a one-time charge or started a subscription.

        - `"payment"`

        - `"subscription"`

      - `natural?: Natural`

        Natural-rail join keys, present when `rail: natural`.

        - `payment_request_id?: string`

          The Natural payment request (`prq_...`).

        - `transaction_id?: string`

          The settled transaction (`txn_...`).

      - `price_id?: string`

        Subscription mode — the recurring price subscribed to.

      - `quantity?: number`

        Subscription mode — units of the price subscribed to.

      - `rail?: "stripe" | "natural"`

        The rail this request settled on.

        - `"stripe"`

        - `"natural"`

      - `stripe?: Stripe`

        Ids of the Stripe objects on your connected account — join
        keys into your own Stripe Dashboard/API. Manage a
        subscription's post-checkout lifecycle with `subscription_id`.

        - `customer_id?: string`

          The Customer the request is attached to (`cus_...`).
          Always set in subscription mode; set in payment mode
          only when the request was created with a `customer_id`.

        - `payment_intent_id?: string`

          The PaymentIntent collected at checkout (`pi_...`).

        - `subscription_id?: string`

          Subscription mode — the Subscription (`sub_...`).

      - `trial_end?: string`

        Subscription mode — when the free trial ends and the first
        charge happens. On a trial request, `payment.succeeded`
        means the payment method was collected ($0 moved).

      - `updated_at?: string`

    - `event_id: string`

      Unique identifier for this event (for deduplication)

    - `event_type: "payment.succeeded" | "payment.canceled" | "payment.expired" | 66 more`

      - `"payment.succeeded"`

      - `"payment.canceled"`

      - `"payment.expired"`

      - `"message.sent"`

      - `"message.received"`

      - `"message.read"`

      - `"message.delivered"`

      - `"message.failed"`

      - `"message.edited"`

      - `"reaction.added"`

      - `"reaction.removed"`

      - `"poll.received"`

      - `"poll.failed"`

      - `"poll.sent"`

      - `"poll.delivered"`

      - `"poll.read"`

      - `"poll.updated"`

      - `"poll.vote.added"`

      - `"poll.vote.removed"`

      - `"poll.reaction.added"`

      - `"participant.added"`

      - `"participant.removed"`

      - `"chat.created"`

      - `"chat.group_name_updated"`

      - `"chat.group_icon_updated"`

      - `"chat.group_name_update_failed"`

      - `"chat.group_icon_update_failed"`

      - `"chat.background_updated"`

      - `"chat.background_update_failed"`

      - `"chat.typing_indicator.started"`

      - `"chat.typing_indicator.stopped"`

      - `"phone_number.status_updated"`

      - `"phone_number.assigned"`

      - `"phone_number.released"`

      - `"phone_number.line_type_updated"`

      - `"contact_card.received"`

      - `"location.sharing.started"`

      - `"location.sharing.stopped"`

      - `"payment.declined"`

      - `"payment.authorized"`

      - `"connection.created"`

      - `"connection.revoked"`

      - `"zero_day_retention.updated"`

      - `"phone_number.forwarding_updated"`

      - `"environment.line_moved"`

      - `"contact_card.created"`

      - `"contact_card.updated"`

      - `"contact_card.deleted"`

      - `"api_token.created"`

      - `"api_token.renamed"`

      - `"api_token.expiry_scheduled"`

      - `"api_token.expired"`

      - `"api_token.activated"`

      - `"api_token.deleted"`

      - `"environment.created"`

      - `"environment.renamed"`

      - `"environment.deleted"`

      - `"webhook_subscription.created"`

      - `"webhook_subscription.deleted"`

      - `"webhook_subscription.target_url_changed"`

      - `"webhook_subscription.enabled"`

      - `"webhook_subscription.disabled"`

      - `"webhook_subscription.events.updated"`

      - `"webhook_subscription.phone_numbers.updated"`

      - `"webhook_subscription.routing_headers_set"`

      - `"webhook_subscription.routing_headers_cleared"`

      - `"team_member.added"`

      - `"team_member.signed_in"`

      - `"team_member.signed_out"`

    - `partner_id: string`

      Partner identifier. Present on all webhooks for cross-referencing.

    - `trace_id: string`

      Trace ID for debugging and correlation across systems.

    - `webhook_version: string`

      Date-based webhook payload version.
      Determined by the `?version=` query parameter in your webhook subscription URL.
      If no version parameter is specified, defaults based on subscription creation date.
